//main.c
#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

void main()
{
	int MainChoice = 0;
    int ret_code = 0;
  
    int nDataLen = 0;
    char szData[4096] = { 0x00 };
    int nDataLen2 = 0;
    char szData2[4096] = { 0x00 };
    char szIcc_appdata[8192] = { 0x00 };
	int iIcType = 0;
 
    MainChoice = ICCMenu();
	while(MainChoice != 0)
	{
		switch(MainChoice)
		{
			case 1:
                //0-usb;1-"/dev/ttyAMA0",2--"/dev/ttyAMA1",3--"/dev/ttyS0",4--"/dev/ttyS1"
				ret_code = star_Open(0, 0, '0');
				printf("ret_code=%d\r\n", ret_code );
		  	break;
			case 2:
				ret_code = star_Close();
				printf("ret_code=%d\n", ret_code );
		  	break;
			case 3:
                 memset(szData,0,strlen(szData));
				ret_code = star_GetDevInfo(szData, &nDataLen);
				printf("ret_code=%d, szData = %s, nDataLen = %d\r\n", ret_code, szData, nDataLen );
		  	break;
			case 4:
				ret_code = star_WriteMagCard("22222", "33333", 10);
				printf("ret_code=%d\r\n", ret_code );
		  	break;
			case 5:
                 memset(szData,0,strlen(szData));
                 memset(szData2,0,strlen(szData2));
				ret_code = star_ReadMagCard( 23, szData, &nDataLen, szData2, &nDataLen2, 10);
				printf("ret_code=%d, szData = %s, nDataLen = %d, szData2 = %s, nDataLen2 = %d\r\n", ret_code, szData, nDataLen, szData2, nDataLen2 );
		  	break;
			case 6:
                memset(szData,0,strlen(szData));
				ret_code = star_ICPowerOn( 2, szData, &nDataLen, &iIcType, 10 );
				printf("ret_code=%d, szData = %s, nDataLen = %d, iIcType = %d\r\n", ret_code, szData, nDataLen, iIcType );
		  	break;
			case 7:
                 memset(szData,0,strlen(szData));
				ret_code = star_ICAPDU( iIcType, "00A404000E315041592E5359532E4444463031", 38, szData, &nDataLen );
				printf("ret_code=%d, szData = %s, nDataLen = %d\r\n", ret_code, szData, nDataLen );
		  	break;
			case 8:
				ret_code = star_ICPowerOff(iIcType);
				printf("ret_code=%d\r\n", ret_code);
		  	break;
			case 9:
                memset(szData,0,strlen(szData));
				ret_code = star_ReadIdInfo( "", szData, &nDataLen, NULL, NULL, NULL, 10 );
				printf("ret_code=%d, szData = %s, nDataLen = %d\r\n", ret_code, szData, nDataLen);
		  	break;
			case 10:
                memset(szData,0,strlen(szData));
				ret_code = star_ICGetInfo( 2, "ABCDEFG", szData, 10 );
				printf("ret_code=%d, szData = %s\r\n", ret_code, szData );
		  	break;
			
            case 11:
                memset(szData,0,strlen(szData));
                ret_code = star_SAMPowerOn( 1, szData, &nDataLen, &iIcType, 30 );
                printf("ret_code=%d, szData = %s\r\n", ret_code, szData );
                break;

            case 12:
                memset(szData,0,strlen(szData));
                ret_code = star_SAMAPDU( 1, "00A404000E315041592E5359532E4444463031", 38, szData, &nDataLen );
                printf("ret_code=%d, szData = %s\r\n", ret_code, szData );
                break;

            case 13:
                ret_code = star_SAMPowerOff( 1 );
                printf("ret_code=%d \r\n", ret_code);
                break;

			default:
		  	break;		
		}
	  MainChoice = ICCMenu();
	}
}

int ICCMenu(void)
{
	int IcChoice;
  do
	{
		printf("\n");
		printf( "          ============================================\n");
		printf( "          =             TEST  DEMO                   =\n");
		printf( "          ============================================\n");
		printf( "          =    [1] star_Open                         =\n");
		printf( "          =    [2] star_Close                        =\n");
		printf( "          =    [3] star_GetDevInfo                   =\n");
		printf( "          =    [4] star_WriteMagCard                 =\n");
		printf( "          =    [5] star_ReadMagCard                  =\n");
		printf( "          =    [6] star_ICPowerOn                    =\n");
		printf( "          =    [7] star_ICAPDU                       =\n");
		printf( "          =    [8] star_ICPowerOff                   =\n");
		printf( "          =    [9] star_ReadIdInfo                   =\n");
		printf( "          =    [10] star_ICGetInfo                   =\n");
        printf( "          =    [11] star_SAMPowerOn                   =\n");
        printf( "          =    [12] star_SAMAPDU                      =\n");
        printf( "          =    [13] star_SAMPowerOff                  =\n");
		printf( "          =    [0] Quit                              =\n");
		printf( "          ============================================\n");
		printf("please select:");
		fflush(stdout);
		fflush(stdin);
		scanf("%d", &IcChoice);
	}while(IcChoice< 0 || IcChoice>13);
	return IcChoice;
}
